import { mat4 } from 'gl-matrix';
import { Vector3 } from '../interfaces/interface';
export declare class Camera {
    position: Vector3;
    type: string;
    lookAtPosition: Vector3;
    viewMatrix: mat4;
    projectionMatrix: mat4;
    constructor(type?: string);
    updatePosition(xx?: number, yy?: number, zz?: number): void;
    updateLookAtPosition(xx?: number, yy?: number, zz?: number): void;
    updateViewMatrix(): void;
}
export declare class PerspectiveCamera extends Camera {
    constructor(width: number, height: number, fov?: number, near?: number, far?: number);
    updatePerspective(width: number, height: number, fov: number, near: number, far: number): void;
}
export declare class OrthoCamera extends Camera {
    constructor(left: number, right: number, bottom: number, top: number, near: number, far: number);
    updatePerspective(left: number, right: number, bottom: number, top: number, near: number, far: number): void;
}
